"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = __importDefault(require("axios"));
var path_1 = __importDefault(require("path"));
/* istanbul ignore next */
function createHTTPClient(global, client) {
    if (global === void 0) { global = window; }
    if (client === void 0) { client = axios_1.default; }
    return {
        fetch: function (_a) {
            var _b = _a.baseURL, baseURL = _b === void 0 ? path_1.default.join(global.location.origin, "api") : _b, _c = _a.url, url = _c === void 0 ? global.location.pathname : _c, config = __rest(_a, ["baseURL", "url"]);
            return client(__assign({}, config, { baseURL: baseURL, url: url })).then(function (_a) {
                var data = _a.data;
                return data;
            });
        }
    };
}
exports.createHTTPClient = createHTTPClient;
/* istanbul ignore next */
exports.default = createHTTPClient();
